unit Preview;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  GrphPrev, ExtCtrls, StdCtrls, jpeg, GIFImage;

type
  TPreviewForm = class(TForm)
    Panel1: TPanel;
    GraphicPreview1: TGraphicPreview;
    Button1: TButton;
    Button2: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    Button3: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Panel2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GraphicPreview1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Panel4MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel5MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel7MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel8MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel9MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel10MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel11MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel12MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel13MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel14MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure DispGraphic;
    procedure DispInfor;
  end;

var
  PreviewForm: TPreviewForm;

implementation

uses Frame;

{$R *.DFM}

procedure TPreviewForm.DispGraphic;
var
  R: TRect;
  Bmp: TBitmap;
  Jpeg: TJPEGImage;
  Gif: TGIFImage;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
begin
  R := Rect(0, 0, FrameForm.TurboImage1.Width, FrameForm.TurboImage1.Height);

  Bmp := TBitmap.Create;
  try
    Bmp.Width := FrameForm.TurboImage1.Width;
    Bmp.Height := FrameForm.TurboImage1.Height;
    Bmp.Canvas.StretchDraw(R, FrameForm.TurboImage1.Picture.Graphic);

    if FrameForm.TurboImage1.Picture.Graphic is TMetafile then
    begin
      Mf := TMetafile.Create;
      try
        Mf.Width := FrameForm.TurboImage1.Width;
        Mf.Height := FrameForm.TurboImage1.Height;
        MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
        try
          MfCanvas.StretchDraw(R, FrameForm.TurboImage1.Picture.Metafile);
        finally
          MfCanvas.Free;
        end;
        Mf.Inch := 1;
        GraphicPreview1.Graphic := Mf;
      finally
        Mf.Free;
      end;
    end
    else if FrameForm.TurboImage1.Picture.Graphic is TBitmap then
      GraphicPreview1.Graphic := Bmp
    else if FrameForm.TurboImage1.Picture.Graphic is TJPEGImage then
    begin
      Jpeg := TJPEGImage.Create;
      Jpeg.CompressionQuality := FrameForm.UpDown1.Position;
      try
        Jpeg.Assign(Bmp);
        GraphicPreview1.Graphic := Jpeg;
      finally
        Jpeg.Free;
      end;
    end
    else if FrameForm.TurboImage1.Picture.Graphic is TGIFImage then
    begin
      Gif := TGIFImage.Create;
      try
        Gif.Assign(Bmp);
        GraphicPreview1.Graphic := Gif;
      finally
        Gif.Free;
      end;
    end
    else
      GraphicPreview1.Graphic := Bmp;
  finally
    Bmp.Free;
  end;
end;

procedure TPreviewForm.FormShow(Sender: TObject);
begin
  Left := FrameForm.Parameter1['PLeft'];
  Top := FrameForm.Parameter1['PTop'];
  ClientWidth := FrameForm.Parameter1['PClientWidth'];
  ClientHeight := FrameForm.Parameter1['PClientHeight'];
  WindowState := TWindowState(FrameForm.Parameter1['PWindowState']);
  GraphicPreview1.PrintRatio := FrameForm.Parameter1['PrintRatio'];
  GraphicPreview1.PreviewRatio := FrameForm.Parameter1['PreviewRatio'];
  GraphicPreview1.GraphicMode := TGraphicMode(FrameForm.Parameter1['GraphicMode']);

  DispGraphic;
  DispInfor;
end;

procedure TPreviewForm.Button1Click(Sender: TObject);
begin
  if FrameForm.PrintDialog1.Execute then
    GraphicPreview1.Print(FrameForm.PrintDialog1.Copies);
end;

procedure TPreviewForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if WindowState <> wsMaximized then
  begin
    FrameForm.Parameter1['PLeft'] := Left;
    FrameForm.Parameter1['PTop'] := Top;
    FrameForm.Parameter1['PClientWidth'] := ClientWidth;
    FrameForm.Parameter1['PClientHeight'] := ClientHeight;
  end;
  FrameForm.Parameter1['PWindowState'] := Integer(WindowState);
  FrameForm.Parameter1['PrintRatio'] := GraphicPreview1.PrintRatio;
  FrameForm.Parameter1['PreviewRatio'] := GraphicPreview1.PreviewRatio;
  FrameForm.Parameter1['GraphicMode'] := Integer(GraphicPreview1.GraphicMode);
end;

procedure TPreviewForm.DispInfor;
begin
  if GraphicPreview1.PrintMode = pmRatio then
    Panel2.Caption := '{'
  else if GraphicPreview1.PrintMode = pmArea then
    Panel2.Caption := '͈'
  else
    Panel2.Caption := '';

  if GraphicPreview1.GraphicMode = gmMetafile then
    Panel3.Caption := 'Metafile'
  else if GraphicPreview1.GraphicMode = gmGraphic then
    Panel3.Caption := 'Graphic'
  else
    Panel3.Caption := '';

  Panel4.Caption := '̔{ = ' + IntToStr(GraphicPreview1.PrintRatio) + ' %';

  Panel5.Caption := 'vr[̔{ = ' + IntToStr(GraphicPreview1.PreviewRatio) + ' %';

  Panel7.Caption := '  (' + IntToStr(GraphicPreview1.PrintRect.Left) + ',';
  Panel8.Caption := IntToStr(GraphicPreview1.PrintRect.Top) + ',';
  Panel9.Caption := IntToStr(GraphicPreview1.PrintRect.Right) + ',';
  Panel10.Caption := IntToStr(GraphicPreview1.PrintRect.Bottom) + ') Pixel';

  Panel11.Caption := '͈  (' + Format('%f', [GraphicPreview1.MMPrintRect.Left]) + ',';
  Panel12.Caption := Format('%f', [GraphicPreview1.MMPrintRect.Top]) + ',';
  Panel13.Caption := Format('%f', [GraphicPreview1.MMPrintRect.Right]) + ',';
  Panel14.Caption := Format('%f', [GraphicPreview1.MMPrintRect.Bottom]) + ') mm';
end;

procedure TPreviewForm.Panel2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if GraphicPreview1.PrintMode = pmRatio then
    GraphicPreview1.PrintMode := pmArea
  else
    GraphicPreview1.PrintMode := pmRatio;
  DispInfor;
end;

procedure TPreviewForm.Panel3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if GraphicPreview1.GraphicMode = gmMetafile then
    GraphicPreview1.GraphicMode := gmGraphic
  else
    GraphicPreview1.GraphicMode := gmMetafile;
  DispInfor;
end;

procedure TPreviewForm.GraphicPreview1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DispInfor;
end;

procedure TPreviewForm.Panel4MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  PR: Integer;
begin
  PR := GraphicPreview1.PrintRatio;
  if Button = mbLeft then
  begin
    if ssCtrl in Shift then PR := PR - 1
    else if ssShift in Shift then PR := PR - 2
    else if ssAlt in Shift then PR := PR - 5
    else PR := PR - 10;
    if PR < 10 then PR := 10;
  end
  else if Button = mbRight then
  begin
    if ssCtrl in Shift then PR := PR + 1
    else if ssShift in Shift then PR := PR + 2
    else if ssAlt in Shift then PR := PR + 5
    else PR := PR + 10;
    if PR > 1000 then
      PR := 1000;
  end;
  GraphicPreview1.PrintRatio := PR;
  if GraphicPreview1.PrintMode <> pmRatio then
    GraphicPreview1.PrintMode := pmRatio; // {Ɉ郂[hɂB
  DispInfor;
end;

procedure TPreviewForm.Panel5MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  PR: Integer;
begin
  PR := GraphicPreview1.PreviewRatio;
  if Button = mbLeft then
  begin
    if ssCtrl in Shift then PR := PR - 1
    else if ssShift in Shift then PR := PR - 2
    else if ssAlt in Shift then PR := PR - 5
    else PR := PR - 10;
    if PR < 10 then PR := 10;
    if PR < 10 then
      PR := 10;
  end
  else if Button = mbRight then
  begin
    if ssCtrl in Shift then PR := PR + 1
    else if ssShift in Shift then PR := PR + 2
    else if ssAlt in Shift then PR := PR + 5
    else PR := PR + 10;
    if PR > 100 then
      PR := 100;
  end;
  GraphicPreview1.PreviewRatio := PR;
  DispInfor;
end;

procedure TPreviewForm.Panel7MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  L: Integer;
  R: TRect;
begin
  if ssCtrl in Shift then L := 1
  else if ssShift in Shift then L := 5
  else if ssAlt in Shift then L := 20
  else L := 50;

  R := GraphicPreview1.PrintRect;
  if Button = mbLeft then
    R := Rect(R.Left - L, R.Top, R.Right - L, R.Bottom)
  else if Button = mbRight then
    R := Rect(R.Left + L, R.Top, R.Right + L, R.Bottom);

  if GraphicPreview1.PrintMode = pmRatio then
    GraphicPreview1.PrintPoint := Point(R.Left, R.Top)
  else if GraphicPreview1.PrintMode = pmArea then
    GraphicPreview1.PrintRect := R;

  DispInfor;
end;

procedure TPreviewForm.Panel8MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  L: Integer;
  R: TRect;
begin
  if ssCtrl in Shift then L := 1
  else if ssShift in Shift then L := 5
  else if ssAlt in Shift then L := 20
  else L := 50;

  R := GraphicPreview1.PrintRect;
  if Button = mbLeft then
    R := Rect(R.Left, R.Top - L, R.Right, R.Bottom - L)
  else if Button = mbRight then
    R := Rect(R.Left, R.Top + L, R.Right, R.Bottom + L);

  if GraphicPreview1.PrintMode = pmRatio then
    GraphicPreview1.PrintPoint := Point(R.Left, R.Top)
  else if GraphicPreview1.PrintMode = pmArea then
    GraphicPreview1.PrintRect := R;

  DispInfor;
end;

procedure TPreviewForm.Panel9MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  L: Integer;
  R: TRect;
begin
  if ssCtrl in Shift then L := 1
  else if ssShift in Shift then L := 5
  else if ssAlt in Shift then L := 20
  else L := 50;

  R := GraphicPreview1.PrintRect;
  if Button = mbLeft then
    R.Right := R.Right - L
  else if Button = mbRight then
    R.Right := R.Right + L;

  GraphicPreview1.PrintRect := R; // Iɔ͈͂Ɉ郂[hɂȂB

  DispInfor;
end;

procedure TPreviewForm.Panel10MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  L: Integer;
  R: TRect;
begin
  if ssCtrl in Shift then L := 1
  else if ssShift in Shift then L := 5
  else if ssAlt in Shift then L := 20
  else L := 50;

  R := GraphicPreview1.PrintRect;
  if Button = mbLeft then
    R.Bottom := R.Bottom - L
  else if Button = mbRight then
    R.Bottom := R.Bottom + L;

  GraphicPreview1.PrintRect := R; // Iɔ͈͂Ɉ郂[hɂȂB

  DispInfor;
end;

procedure TPreviewForm.Panel11MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  L: Double;
  R: TDoubleRect;
begin
  if ssCtrl in Shift then L := 0.50
  else if ssShift in Shift then L := 1.00
  else if ssAlt in Shift then L := 2.00
  else L := 5.00;

  R := GraphicPreview1.MMPrintRect;
  if Button = mbLeft then
    R := DoubleRect(R.Left - L, R.Top, R.Right - L, R.Bottom)
  else if Button = mbRight then
    R := DoubleRect(R.Left + L, R.Top, R.Right + L, R.Bottom);

  if GraphicPreview1.PrintMode = pmRatio then
    GraphicPreview1.MMPrintPoint := DoublePoint(R.Left, R.Top)
  else if GraphicPreview1.PrintMode = pmArea then
    GraphicPreview1.MMPrintRect := R;

  DispInfor;
end;

procedure TPreviewForm.Panel12MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  L: Double;
  R: TDoubleRect;
begin
  if ssCtrl in Shift then L := 0.50
  else if ssShift in Shift then L := 1.00
  else if ssAlt in Shift then L := 2.00
  else L := 5.00;

  R := GraphicPreview1.MMPrintRect;
  if Button = mbLeft then
    R := DoubleRect(R.Left, R.Top - L, R.Right, R.Bottom - L)
  else if Button = mbRight then
    R := DoubleRect(R.Left, R.Top + L, R.Right, R.Bottom + L);

  if GraphicPreview1.PrintMode = pmRatio then
    GraphicPreview1.MMPrintPoint := DoublePoint(R.Left, R.Top)
  else if GraphicPreview1.PrintMode = pmArea then
    GraphicPreview1.MMPrintRect := R;

  DispInfor;
end;

procedure TPreviewForm.Panel13MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  L: Double;
  R: TDoubleRect;
begin
  if ssCtrl in Shift then L := 0.50
  else if ssShift in Shift then L := 1.00
  else if ssAlt in Shift then L := 2.00
  else L := 5.00;

  R := GraphicPreview1.MMPrintRect;
  if Button = mbLeft then
    R.Right := R.Right - L
  else if Button = mbRight then
    R.Right := R.Right + L;

  GraphicPreview1.MMPrintRect := R; // Iɔ͈͂Ɉ郂[hɂȂB

  DispInfor;
end;

procedure TPreviewForm.Panel14MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  L: Double;
  R: TDoubleRect;
begin
  if ssCtrl in Shift then L := 0.50
  else if ssShift in Shift then L := 1.00
  else if ssAlt in Shift then L := 2.00
  else L := 5.00;

  R := GraphicPreview1.MMPrintRect;
  if Button = mbLeft then
    R.Bottom := R.Bottom - L
  else if Button = mbRight then
    R.Bottom := R.Bottom + L;

  GraphicPreview1.MMPrintRect := R; // Iɔ͈͂Ɉ郂[hɂȂB

  DispInfor;
end;

procedure TPreviewForm.Button3Click(Sender: TObject);
begin
  Button2.SetFocus;
  if Button3.Caption = '' then
  begin
    GraphicPreview1.DispPaperInfo;
    Button3.Caption := '摜';
    Button3.Hint := '摜\܂B';
  end
  else if Button3.Caption = '摜' then
  begin
    DispGraphic;
    Button3.Caption := '';
    Button3.Hint := '\܂B';
  end;
end;

end.
